import Taro from '@tarojs/taro'
import dayjs from 'dayjs'

// 未开始
const STATUS_READY = -1

// 进行中
const STATUS_PROCESSING = 0

// 已结束
const STATUS_OVER = 1

export default class TimeTicker extends Taro.Component {

  state = {
    status: STATUS_READY,
    tmStart: undefined,
    tmEnd: undefined,
    preText: undefined,
    tkText: undefined,
  }

  timer = null

  componentWillMount() {


  }

  computeProps(props) {
    const { timeRange } = props || {}
    const now = dayjs().valueOf()
    const [t1, t2] = timeRange || []
    
    // 当前状态 -  默认未开始
    let status = this.state.status
    let tmStart = undefined
    let tmEnd = undefined

    // 没有设置起止时间
    if (!t1 && !t2) {
      throw new Error('TimeTicker has no timeRange setting')
    }

    if (!t1 || !t2) {
      // 只设置了一个时间
      targetTime = t1 ? dayjs(t1).valueOf() : dayjs(t2).valueOf()

      if (now > targetTime) {
        status = STATUS_OVER
      } else if (now === targetTime) {
        status = STATUS_PROCESSING
      } else {
        status = STATUS_READY
      }
    } else {
      // 设置了时间区间
      const dtStart = dayjs(t1).valueOf()
      const dtEnd = dayjs(t2).valueOf()

      if (dtStart > now) {
        status = STATUS_READY
        targetTime = dtStart
      } else if (dtStart <= now && now < dtEnd) {
        status = STATUS_PROCESSING
        targetTime = dtEnd
      } else {
        status = STATUS_OVER
        targetTime = dtEnd
      }
    }

    this.setState({ status, targetTime }, this.startTimer.bind(this))
  }

  startTimer = (props) => {
    const {
      status,
      targetTime,
      interval = 1000,
      onStart,
      onProcess,
      onEnd,
    } = props || {}

    if (this.timer) {
      clearInterval(this.timer)
    }

    this.timer = setInterval(() => {
      const now = dayjs().valueOf()
      const diff = targetTime - now



    }, interval)

  }

  render() {
    


  }
}
